SystemOrganization addCategory: #'Xpf-Multipoint-Plugin'!

Object subclass: #MultiPointer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

MultiPointer class
	instanceVariableNames: 'sema'!

MultiPointer class
	instanceVariableNames: 'sema'!

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:30'!
getPointerCount

	<primitive: 'primitiveMultiPointerCount' module: 'MultiPointerPlugin'>
	^ 42! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/23/2009 11:56'!
getPointerCurrentPoint: aPointerID

	<primitive: 'primitiveMultiPointerCurrentPoint' module: 'MultiPointerPlugin'>
	^ 42 asPoint! !

!MultiPointer class methodsFor: 'as yet unclassified' stamp: 'mig 4/22/2009 17:34'!
getPointerName: aPointerID

	| pointerName |
	pointerName := self pvtGetPointerName: aPointerID.
	^ pointerName truncateTo: (pointerName 
			indexOf: (Character value: 0) 
			startingAt: 0 
			ifAbsent: [pointerName size + 1]) - 1! !

!MultiPointer class methodsFor: 'class initialization' stamp: 'SR 4/23/2009 14:17'!
initialize

	super initialize.
	Smalltalk addToStartUpList: self.
	Smalltalk addToShutDownList: self.! !

!MultiPointer class methodsFor: 'primitives' stamp: 'mig 4/22/2009 16:56'!
pvtGetPointerName: aPointerID

	<primitive: 'primitiveMultiPointerName' module: 'MultiPointerPlugin'>
	^ 'Pointing Device'! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:28'!
registerSemaphore

	| semaIndex |
	Transcript show: 'registerSemaphore'; cr.
	sema := Semaphore new.
	semaIndex := Smalltalk registerExternalObject: sema.
	self setPointerSemaphoreHandle: semaIndex.! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/23/2009 14:27'!
sema

	^ sema! !

!MultiPointer class methodsFor: 'accessing' stamp: 'SR 4/23/2009 14:27'!
sema: anObject

	sema := anObject! !

!MultiPointer class methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:20'!
setPointerSemaphoreHandle: aSemaIndex

	<primitive: 'primitiveMultiPointerSemaphoreHandle' module: 'MultiPointerPlugin'>! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:19'!
shutDown: aboutToQuit 

	self unregisterSemaphore.
	super shutDown: aboutToQuit.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:19'!
startUp: aboutToQuit 

	self registerSemaphore.
	super startUp: aboutToQuit.! !

!MultiPointer class methodsFor: 'system startup' stamp: 'SR 4/23/2009 14:28'!
unregisterSemaphore

	| |
	Transcript show: 'unregisterSemaphore';cr.
	self setPointerSemaphoreHandle: 0.
	Smalltalk unregisterExternalObject: sema.
	sema := nil.
! !

SmartSyntaxInterpreterPlugin subclass: #MultiPointerPlugin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xpf-Multipoint-Plugin'!

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:07'!
hasHeaderFile
	"If there is a single intrinsic header file to be associated with the plugin, here is where you want to flag"
	^ true! !

!MultiPointerPlugin class methodsFor: 'translation' stamp: 'SR 4/22/2009 14:08'!
requiresPlatformFiles
	"this plugin requires platform specific files in order to work"
	^ true! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
initialiseModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerInit()' inSmalltalk:[true]! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 13:23'!
moduleUnloaded: aModuleName 
	"The module with the given name was just unloaded. 
	Make sure we have no dangling references."
	self export: true.! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/22/2009 14:28'!
primitiveMultiPointerCount

	| r |
	self primitive: 'primitiveMultiPointerCount'.
	r := self cCode:' multiPointerCount()'.
	^r asOop: SmallInteger! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 13:36'!
primitiveMultiPointerCurrentPoint: aPointerID

	| oop result inputX inputY |
	self primitive:'primitiveMultiPointerCurrentPoint'.
	self var: 'inputX' declareC: 'int inputX'.
	self var: 'inputY' declareC: 'int inputY'.
	result := (self cCode: 'multiPointerCurrentPoint(interpreterProxy->integerValueOf(aPointerID), &inputX, &inputY)') asOop: SmallInteger.
	oop := interpreterProxy makePointwithxValue: inputX yValue: inputY.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:24'!
primitiveMultiPointerName: aPointerID

	| oop length buffer |
	self primitive:'primitiveMultiPointerName'.
	length := self multiPointerNameLength:  (interpreterProxy integerValueOf: aPointerID).
	oop := interpreterProxy instantiateClass: interpreterProxy classString indexableSize: length.
	buffer :=  interpreterProxy firstIndexableField: oop.
	self cCode: 'multiPointerName(interpreterProxy->integerValueOf(aPointerID), interpreterProxy->integerValueOf(length), buffer)'.
	^ oop! !

!MultiPointerPlugin methodsFor: 'primitives' stamp: 'SR 4/23/2009 14:23'!
primitiveMultiPointerSemaphoreHandle: aSemaIndex

	| |
	self primitive:'primitiveMultiPointerSemaphoreHandle' parameters: #(#SmallInteger).
	self multiPointerSetSemaphore: aSemaIndex.! !

!MultiPointerPlugin methodsFor: 'initialize-release' stamp: 'SR 4/22/2009 14:28'!
shutdownModule
	"Initialise the module"
	self export: true.
	^self cCode: 'multiPointerShutdown()' inSmalltalk:[true]! !
MultiPointer initialize!
